function GBH_CreateFactionView()
   local i,frame,textString,moneyFrame   
   
   --GBH_UIFrame:SetScript("OnShow",GBH_UIShow)   
   GBH_FactionScrollFrame:EnableMouse()
   GBH_FactionScrollFrame:EnableMouseWheel(1)   
   GBH_FactionScrollFrame:SetScript("OnShow",GBH_FactionFrameUpdate) 
   GBH_FactionScrollFrame:SetScript("OnUpdate",GBH_FactionFrameUpdate)
   GBH_FactionScrollFrame:Show()   
   --MoneyFrame_Update(GBH_LargessAmountFrame, GBL_Largess); 
   
   --List Entry Frames (faux scroll frames)
   for i = 0,GBH_NUM_HITLIST_ENTRIES-1 do       
      frame = CreateFrame("Button","GBH_FactionEntry"..i,GBH_FactionScrollFrame,"GBH_FactionEntryTemplate")
      frame:SetPoint("TOPLEFT",0,-i*17)
      frame:Show() 
   end 
   GBH_ListEntryNormalTexture = frame:GetNormalTexture()
   GBH_FactionScrollFrame:SetPoint("TOPLEFT",10,-100) 
   GBH_FactionCurrentEntry = 0
   
   --init guild faction reputation exit box
   GBH_ReputationEditBox:SetText("0")
 
end  

function GBH_FactionFrameUpdate()
    local i,dataOffset,offset,n,m,name
    local moneyFrame,textString,entryFrame,negLargess,faction
    local repLvlStr, lvl, pts, rmax, r,g,b, ri
    
    --GBL_SetupFactionViewList()
    --n = #GBL_FactionViewList
    n = #GBL_GuildMates
    FauxScrollFrame_Update(GBH_FactionScrollFrame,n,GBH_NUM_HITLIST_ENTRIES,17,nil,nil,nil,nil,nil,nil,true);
    offset = FauxScrollFrame_GetOffset(GBH_FactionScrollFrame);
       
    for i = 0,GBH_NUM_HITLIST_ENTRIES-1 do
        dataOffset = offset + i + 1      
        textString = _G["GBH_FactionEntry"..i.."_GuildieName"]
        repString = _G["GBH_FactionEntry"..i.."_Reputation"]        
        entryFrame = _G["GBH_FactionEntry"..i]      
        if dataOffset <= n then
            name = GBL_GuildMates[dataOffset].name
            textString:SetText(name)
            faction = UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu)
            if faction == GBL_GuildFactions[1].title then
                lvl, pts, rmax = GBL_GrpToRepLevel(GBL_GuildFactionData[name].rep1)
                --lvl, pts, rmax = GBL_GrpToRepLevel(GBL_FactionViewList[dataOffset].rep1)
                repLvlStr = lvl.." "..pts.."/"..rmax
                
            elseif faction == GBL_GuildFactions[2].title then
                lvl, pts, rmax = GBL_GrpToRepLevel(GBL_GuildFactionData[name].rep2)
                --lvl, pts, rmax = GBL_GrpToRepLevel(GBL_FactionViewList[dataOffset].rep2)
                repLvlStr = lvl.." "..pts.."/"..rmax
                
            elseif faction == GBL_GuildFactions[3].title then   
                lvl, pts, rmax = GBL_GrpToRepLevel(GBL_GuildFactionData[name].rep3)
                --lvl, pts, rmax = GBL_GrpToRepLevel(GBL_FactionViewList[dataOffset].rep3)
                repLvlStr = lvl.." "..pts.."/"..rmax
               
            elseif faction == GBL_GuildFactions[4].title then     
                lvl, pts, rmax = GBL_GrpToRepLevel(GBL_GuildFactionData[name].rep4)
                --lvl, pts, rmax = GBL_GrpToRepLevel(GBL_FactionViewList[dataOffset].rep4)
                repLvlStr = lvl.." "..pts.."/"..rmax
               
            elseif faction == GBL_GuildFactions[5].title then 
                lvl, pts, rmax = GBL_GrpToRepLevel(GBL_GuildFactionData[name].rep5)
                --lvl, pts, rmax = GBL_GrpToRepLevel(GBL_FactionViewList[dataOffset].rep5)
                repLvlStr = lvl.." "..pts.."/"..rmax
                
            end
            
            r,g,b = GBH_FactionGetRepColor(lvl)
            repString:SetTextColor(r,g,b)
            repString:SetText(repLvlStr)
            entryFrame.index = dataOffset
            if GBH_FactionCurrentEntry == dataOffset then
                --set selected texture            
                entryFrame:LockHighlight()
            else
                --reset normal texture
                entryFrame:UnlockHighlight()
            end        
            entryFrame:Show()         
        else
            entryFrame:Hide()                
        end        
    end    
end

function GBH_FactionEntryOnClick(self)
    GBH_FactionCurrentEntry = self.index
    local faction = UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu)
    local replevel, pts, name
    
    name = GBL_GuildMates[self.index].name
    if faction == GBL_GuildFactions[1].title then 
        pts = GBL_GuildFactionData[name].rep1
    elseif faction == GBL_GuildFactions[2].title then
        pts = GBL_GuildFactionData[name].rep2
    elseif faction == GBL_GuildFactions[3].title then
        pts = GBL_GuildFactionData[name].rep3
    elseif faction == GBL_GuildFactions[4].title then
        pts = GBL_GuildFactionData[name].rep4
    elseif faction == GBL_GuildFactions[5].title then
        pts = GBL_GuildFactionData[name].rep5
    end
    replevel, _, _ = GBL_GrpToRepLevel(pts)
    UIDropDownMenu_SetSelectedValue(GBH_FactionRepMenu, replevel) 
    GBL_LargessMessage(replevel)
    --insert cool things here
    --GBH_FactionFrameUpdate()    
end

function GBH_FactionAddRep(player, rep1, rep2, rep3, rep4, rep5)
    local rep01, rep02, rep03, rep04, rep05 = GBL_FactionGetRep(player)
    
    if rep1 == nil then 
        rep1 = 0
    end
    if rep2 == nil then
        rep2 = 0
    end
    if rep3 == nil then
        rep3 = 0
    end
    if rep4 == nil then
        rep4 = 0
    end
    if rep5 == nil then
        rep5 = 0
    end
    
    GBL_FactionSetRep(player, tonumber(rep01)+tonumber(rep1), tonumber(rep02)+tonumber(rep2), tonumber(rep03)+tonumber(rep3), tonumber(rep04)+tonumber(rep4), tonumber(rep05)+tonumber(rep5))
end

function GBH_FactionSubRep(player, rep1, rep2, rep3, rep4, rep5)
    local rep01, rep02, rep03, rep04, rep05 = GBL_FactionGetRep(player)
    
    if rep1 == nil then 
        rep1 = 0
    end
    if rep2 == nil then
        rep2 = 0
    end
    if rep3 == nil then
        rep3 = 0
    end
    if rep4 == nil then
        rep4 = 0
    end
    if rep5 == nil then
        rep5 = 0
    end
    
    GBL_FactionSetRep(player, rep01-rep1, rep02-rep2, rep03-rep3, rep04-rep4, rep05-rep5)
end
    
function GBH_DisplayFactionView()
    GBH_LargessViewFrame:Hide()  
    GBH_UIFrame:Hide()   
    GBH_ItemLargessFrame:Hide()
    GBH_FactionViewFrame:Show()
    --GBH_LargessAmountFrame:Hide()
    --GBH_AddBountyButton:Hide()
    --GBH_HitListFrameTexture1:Hide()
    
    --set portrait icon
    SetPortraitToTexture(GBH_HitListFrameSkullnXBonesTexture,"interface\\icons\\Achievement_General_DungeonDiplomat")
end

function GBH_FactionDetailsAddRep()
    local rep = GBH_ReputationEditBox:GetText()
    GBL_LargessMessage(rep)
    GBL_LargessMessage(GBH_FactionCurrentEntry)
    local player = GBL_GuildMates[GBH_FactionCurrentEntry].name
    GBL_LargessMessage(player)
    local faction = UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu)
    if faction == GBL_GuildFactions[1].title then
        GBH_FactionAddRep(player, rep, nil, nil, nil, nil)
    elseif faction == GBL_GuildFactions[2].title then
        GBH_FactionAddRep(player, nil, rep, nil, nil, nil)
    elseif faction == GBL_GuildFactions[3].title then            
        GBH_FactionAddRep(player, nil, nil, rep, nil, nil)
    elseif faction == GBL_GuildFactions[4].title then            
        GBH_FactionAddRep(player, nil, nil, nil, rep, nil)
    elseif faction == GBL_GuildFactions[5].title then            
        GBH_FactionAddRep(player, nil, nil, nil, nil, rep)
    end
    GBH_FactionFrameUpdate()
end

function GBH_FactionDetailsSubRep()
    local rep = GBH_ReputationEditBox:GetText()
    local player = GBL_GuildMates[GBH_FactionCurrentEntry].name
    local faction = UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu)
    
    gbh_debug(rep)    
    gbh_debug(player)
    gbh_debug(faction)       
    
    if faction == GBL_GuildFactions[1].title then
        GBH_FactionSubRep(player, rep, nil, nil, nil, nil)
    elseif faction == GBL_GuildFactions[2].title then
        GBH_FactionSubRep(player, nil, rep, nil, nil, nil)
    elseif faction == GBL_GuildFactions[3].title then            
        GBH_FactionSubRep(player, nil, nil, rep, nil, nil)
    elseif faction == GBL_GuildFactions[4].title then            
        GBH_FactionSubRep(player, nil, nil, nil, rep, nil)
    elseif faction == GBL_GuildFactions[5].title then            
        GBH_FactionSubRep(player, nil, nil, nil, nil, rep)
    end
    
    GBH_FactionFrameUpdate()
end

--[[function GBH_FactionDetailsSetRep(guild, raid)    
    local rep = GBH_ReputationEditBox:GetText()
    local player, nr, np, i
    local faction = UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu)
    local replevel = UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu)
    local grp = GRP_RepLevelToGrp(replevel, rep)
    
    gbh_debug(rep)
    gbh_debug(GBH_FactionCurrentEntry)
    --gbh_debug(player)
    
    if guild == nil and raid == nil then        
        player = GBL_GuildMates[GBH_FactionCurrentEntry].name
        if faction == GBL_GuildFactions[1].title then
            GBL_FactionSetRep(player, grp, nil, nil, nil, nil)
        elseif faction == GBL_GuildFactions[2].title then
            GBL_FactionSetRep(player, nil, grp, nil, nil, nil)
        elseif faction == GBL_GuildFactions[3].title then            
            GBL_FactionSetRep(player, nil, nil, grp, nil, nil)
        elseif faction == GBL_GuildFactions[4].title then            
            GBL_FactionSetRep(player, nil, nil, nil, grp, nil)
        elseif faction == GBL_GuildFactions[5].title then            
            GBL_FactionSetRep(player, nil, nil, nil, nil, grp)
        end    
    elseif guild ~= nil then       
        if faction == GBL_GuildFactions[1].title then
            GBL_FactionSetRepGuild(grp, nil, nil, nil, nil)
        elseif faction == GBL_GuildFactions[2].title then
            GBL_FactionSetRepGuild(nil, grp, nil, nil, nil)
        elseif faction == GBL_GuildFactions[3].title then            
            GBL_FactionSetRepGuild(nil, nil, grp, nil, nil)
        elseif faction == GBL_GuildFactions[4].title then            
            GBL_FactionSetRepGuild(nil, nil, nil, grp, nil)
        elseif faction == GBL_GuildFactions[5].title then            
            GBL_FactionSetRepGuild(nil, nil, nil, nil, grp)
        end        
    elseif raid ~= nil then
        --raid
        local nr = GetNumRaidMembers()
        local np = GetNumPartyMembers()
        if nr > 0 then            
            for i = 1, nr do
                player, _, _, _, _, _, _, online, _, _, _ = GetRaidRosterInfo(i)
                if UnitIsInMyGuild(player) and player ~= UnitName("player") and online then
                    if faction == GBL_GuildFactions[1].title then
                        GBL_FactionSetRep(player, grp, nil, nil, nil, nil)
                    elseif faction == GBL_GuildFactions[2].title then
                        GBL_FactionSetRep(player, nil, grp, nil, nil, nil)
                    elseif faction == GBL_GuildFactions[3].title then            
                        GBL_FactionSetRep(player, nil, nil, grp, nil, nil)
                    elseif faction == GBL_GuildFactions[4].title then            
                        GBL_FactionSetRep(player, nil, nil, nil, grp, nil)
                    elseif faction == GBL_GuildFactions[5].title then            
                        GBL_FactionSetRep(player, nil, nil, nil, nil, grp)
                    end    
                end
            end      
        elseif np > 0 then         
            --party
            for i = 1, np do
                player = UnitName("party"..i)
                if UnitIsInMyGuild(player) and player ~= UnitName("player") then
                    if faction == GBL_GuildFactions[1].title then
                            GBL_FactionSetRep(player, grp, nil, nil, nil, nil)
                    elseif faction == GBL_GuildFactions[2].title then
                        GBL_FactionSetRep(player, nil, grp, nil, nil, nil)
                    elseif faction == GBL_GuildFactions[3].title then            
                        GBL_FactionSetRep(player, nil, nil, grp, nil, nil)
                    elseif faction == GBL_GuildFactions[4].title then            
                        GBL_FactionSetRep(player, nil, nil, nil, grp, nil)
                    elseif faction == GBL_GuildFactions[5].title then            
                        GBL_FactionSetRep(player, nil, nil, nil, nil, grp)
                    end    
                end
            end
        end
    end  
    
    GBH_FactionFrameUpdate()
end ]]--

--called when the set guild rep button (=) is clicked
function GBH_FactionDetailsSetRep(guild, raid)
    local group = UIDropDownMenu_GetSelectedValue(GBH_SetRepApplyToMenu)
    --local faction = UIDropDownMenu_GetSelectedID(GBH_ItemFactionSelectMenu) or 1
    local faction = UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu)
    local replevel = UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu)
    local rep = GBH_ReputationEditBox:GetText()
    local grp = GRP_RepLevelToGrp(replevel, rep)    
    
    --faction title to ID
    if faction == GBL_GuildFactions[1].title then
        faction = 1
    elseif faction == GBL_GuildFactions[2].title then
        faction = 2
    elseif faction == GBL_GuildFactions[3].title then
        faction = 3
    elseif faction == GBL_GuildFactions[4].title then
        faction = 4
    elseif faction == GBL_GuildFactions[5].title then
        faction = 5
    end
        
    if group == "Player" then 
        player = GBL_GuildMates[GBH_FactionCurrentEntry].name
        if faction == 1 then
            GBL_FactionSetRep(player, grp, nil, nil, nil, nil)
        elseif faction == 2 then
            GBL_FactionSetRep(player, nil, grp, nil, nil, nil)
        elseif faction == 3 then            
            GBL_FactionSetRep(player, nil, nil, grp, nil, nil)
        elseif faction == 4 then            
            GBL_FactionSetRep(player, nil, nil, nil, grp, nil)
        elseif faction == 5 then            
            GBL_FactionSetRep(player, nil, nil, nil, nil, grp)
        end    
    else
        GBH_SetGuildRep(group, faction, replevel, rep)
    end
end

function GBH_FactionSelectMenuOnClick(self)
    --GBL_LargessMessage("Faction Click...")
    ToggleDropDownMenu(1, nil, GBH_FactionDropDownFrame, self:GetName(), -100, 0)
end

function GBH_FactionSelectMenuInitialize()

    gbh_debug("Faction Init") 
    
    GBH_FactionSelectMenuButton:SetScript("OnClick", GBH_FactionSelectMenuOnClick)
    
    --Menu Title
    local info = {}
    info.text = "Guild Factions"
    info.isTitle = true
    info.notCheckable = true
    --if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == GBL_GuildFactions[1].title then
    --    info.checked = true
    --else
    --    info.checked = nil
    --end
    UIDropDownMenu_AddButton(info)
    
    --Faction 1    
    info = {}
    info.text = GBL_GuildFactions[1].title       
    info.func = GBH_FactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == GBL_GuildFactions[1].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 2
    info = {}
    info.text = GBL_GuildFactions[2].title
    info.func = GBH_FactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == GBL_GuildFactions[2].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 3
    info = {}
    info.text = GBL_GuildFactions[3].title
    info.func = GBH_FactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == GBL_GuildFactions[3].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 4
    info = {}
    info.text = GBL_GuildFactions[4].title
    info.func = GBH_FactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == GBL_GuildFactions[4].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Faction 5
    info = {}
    info.text = GBL_GuildFactions[5].title
    info.func = GBH_FactionMenuItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == GBL_GuildFactions[5].title then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)  
    
    --default value
    if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == nil then
        UIDropDownMenu_SetSelectedValue(GBH_FactionSelectMenu, GBL_GuildFactions[1].title)
    end
end

function GBH_SetRepApplyToMenuInitialize()

    --gbh_debug("SetRepApplyTo") 
    
    GBH_SetRepApplyToMenuButton:SetScript("OnClick", GBH_SetRepApplyToOnClick)
    
    --Menu Title
    local info = {}
    info.text = "Apply To"
    info.isTitle = true
    info.notCheckable = true
    --if UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu) == GBL_GuildFactions[1].title then
    --    info.checked = true
    --else
    --    info.checked = nil
    --end
    UIDropDownMenu_AddButton(info)
    
    --Player   
    info = {}
    info.text = "Player"       
    info.func = GBH_SetRepApplyToItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_SetRepApplyToMenu) == "Player" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Guild
    info = {}
    info.text = "Guild"
    info.func = GBH_SetRepApplyToItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_SetRepApplyToMenu) == "Guild" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Party
    info = {}
    info.text = "Party"
    info.func = GBH_SetRepApplyToItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_SetRepApplyToMenu) == "Party" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --Raid
    info = {}
    info.text = "Raid"
    info.func = GBH_SetRepApplyToItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_SetRepApplyToMenu) == "Raid" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)   
    --default value
    if UIDropDownMenu_GetSelectedValue(GBH_SetRepApplyToMenu) == nil then
        UIDropDownMenu_SetSelectedValue(GBH_SetRepApplyToMenu, "Player")
    end
end

function GBH_SetRepApplyToItemClick(self)
    gbh_debug(self.value)    
    UIDropDownMenu_SetSelectedValue(GBH_SetRepApplyToMenu, self.value)  
    UIDropDownMenu_SetSelectedValue(GBH_SetRepApplyToMenu, self.value) 
    GBH_SetRepApplyToMenuInitialize()
    --GBH_FactionDetailsOnShow()
    --GBH_FactionFrameUpdate()
end

function GBH_FactionRepMenuInitialize()
    --GBL_LargessMessage("Faction Init") 
    GBH_FactionRepMenuButton:SetScript("OnClick", GBH_FactionRepMenuOnClick)
    
    local info ={}
    info.text = "Standing"
    info.isTitle = true
    info.notCheckable = true
    UIDropDownMenu_AddButton(info)
    
    info = {}
    info.text = "Exalted"        
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Exalted" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    info.text = "Revered"
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Revered" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    info.text = "Honored"    
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Honored" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    info.text = "Friendly"
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Friendly" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    info.text = "Neutral"
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Neutral" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    info.text = "Unfriendly"    
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Unfriendly" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    info.text = "Hostile"
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Hostile" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    info.text = "Hated"
    info.func = GBH_FactionRepItemClick
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == "Hated" then
        info.checked = true
    else
        info.checked = nil
    end
    UIDropDownMenu_AddButton(info)
    
    --default value
    if UIDropDownMenu_GetSelectedValue(GBH_FactionRepMenu) == nil then
        UIDropDownMenu_SetSelectedValue(GBH_FactionRepMenu, "Neutral")
    end
end

function GBH_FactionSelectDropDownOnLoad(self)
    --GBL_LargessMessage("Faction OnLoad")
    UIDropDownMenu_Initialize(self, GBH_FactionSelectMenuInitialize)
end

function GBH_SetRepApplyToDropDownOnLoad(self)
    --GBL_LargessMessage("Faction OnLoad")
    UIDropDownMenu_Initialize(self, GBH_SetRepApplyToMenuInitialize)
end

function GBH_FactionMenuItemClick(self)    
    gbh_debug(self.value)    
    UIDropDownMenu_SetSelectedValue(GBH_FactionSelectMenu, self.value)  
    UIDropDownMenu_SetSelectedValue(GBH_FactionSelectMenu, self.value) 
    GBH_FactionRepMenuInitialize()
    GBH_FactionDetailsOnShow()
    --GBH_FactionFrameUpdate()
end

function GBH_FactionRepDropDownOnLoad(self)
    --GBL_LargessMessage("Faction OnLoad")
    UIDropDownMenu_Initialize(self, GBH_FactionRepMenuInitialize)
end

function GBH_FactionRepItemClick(self)        
    gbh_debug(self.value)    
    UIDropDownMenu_SetSelectedValue(GBH_FactionRepMenu, self.value)   
    --GBH_FactionDetailsOnShow()
    GBH_FactionRepMenuInitialize()
end

function GBH_FactionRepMenuOnClick(self)
    --GBL_LargessMessage("Faction Click...")
    ToggleDropDownMenu(1, nil, GBH_FactionRepDropDownFrame, self:GetName(), -100, 0)
end

function GBH_SetRepApplyToOnClick(self)
    --GBL_LargessMessage("Faction Click...")
    ToggleDropDownMenu(1, nil, GBH_SetRepApplyToDropDownFrame, self:GetName(), -100, 0)
end

function GBH_FactionGetRepColor(str)
    local r,g,b
    if str == "Hated" then
        r = FACTION_BAR_COLORS[1].r
        g = FACTION_BAR_COLORS[1].g
        b = FACTION_BAR_COLORS[1].b
        return r,g,b
    end
    if str == "Hostile" then
        r = FACTION_BAR_COLORS[2].r
        g = FACTION_BAR_COLORS[2].g
        b = FACTION_BAR_COLORS[2].b
        return r,g,b
    end
    if str == "Unfriendly" then
        r = FACTION_BAR_COLORS[3].r
        g = FACTION_BAR_COLORS[3].g
        b = FACTION_BAR_COLORS[3].b
        return r,g,b
    end
    if str == "Neutral" then
        r = FACTION_BAR_COLORS[4].r
        g = FACTION_BAR_COLORS[4].g
        b = FACTION_BAR_COLORS[4].b
        return r,g,b
    end
    if str == "Friendly" then
        r = FACTION_BAR_COLORS[5].r
        g = FACTION_BAR_COLORS[5].g
        b = FACTION_BAR_COLORS[5].b
        return r,g,b
    end
    if str == "Honored" then
        r = FACTION_BAR_COLORS[6].r
        g = FACTION_BAR_COLORS[6].g
        b = FACTION_BAR_COLORS[6].b
        return r,g,b
    end
    if str == "Revered" then
        r = FACTION_BAR_COLORS[7].r
        g = FACTION_BAR_COLORS[7].g
        b = FACTION_BAR_COLORS[7].b
        return r,g,b
    end
    if str == "Exalted" then
        r = FACTION_BAR_COLORS[8].r
        g = FACTION_BAR_COLORS[8].g
        b = FACTION_BAR_COLORS[8].b
        return r,g,b
    end
end

function GBH_ToggleFactionDetails()
    if GBH_FactionScrollFrame:IsShown() then
       GBH_FactionScrollFrame:Hide()
       GBH_FactionDetailsScrollFrame:Show()
    else
       GBH_FactionViewFrame:Show()
       GBH_FactionScrollFrame:Show()
       GBH_FactionDetailsScrollFrame:Hide()
    end
end

function GBH_FactionDetailsOnShow()
    --local faction = UIDropDownMenu_GetSelectedValue(GBH_FactionSelectMenu)
    local faction = UIDropDownMenu_GetSelectedID(GBH_FactionSelectMenu)
    
    if faction == nil then
        faction = 2
    end
    
    GBH_CurrentFactionIndex = faction - 1
    GBH_FactionDetailsFormName:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].title)    
    
    GBH_FactionDetailsFormDescription:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].description)
    GBH_FactionDetailsFormMoneyRepGold:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].goldtorep)
    GBH_FactionDetailsFormBountyRepGold:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].bountytorep)
    GBH_FactionDetailsFormRepairsRepGold:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].repairstorep)
    GBH_FactionDetailsForm11:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][1])
    GBH_FactionDetailsForm12:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][2])
    GBH_FactionDetailsForm13:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][3])
    GBH_FactionDetailsForm14:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][4])
    GBH_FactionDetailsForm21:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][1])
    GBH_FactionDetailsForm22:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][2])
    GBH_FactionDetailsForm23:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][3])
    GBH_FactionDetailsForm24:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][4])
    GBH_FactionDetailsForm31:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][1])
    GBH_FactionDetailsForm32:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][2])
    GBH_FactionDetailsForm33:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][3])
    GBH_FactionDetailsForm34:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][4])
    GBH_FactionDetailsForm41:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][1])
    GBH_FactionDetailsForm42:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][2])
    GBH_FactionDetailsForm43:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][3])
    GBH_FactionDetailsForm44:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][4])
    GBH_FactionDetailsForm51:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][1])
    GBH_FactionDetailsForm52:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][2])
    GBH_FactionDetailsForm53:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][3])
    GBH_FactionDetailsForm54:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][4])
    GBH_FactionDetailsForm61:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][1])
    GBH_FactionDetailsForm62:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][2])
    GBH_FactionDetailsForm63:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][3])
    GBH_FactionDetailsForm64:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][4])
    GBH_FactionDetailsForm71:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][1])
    GBH_FactionDetailsForm72:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][2])
    GBH_FactionDetailsForm73:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][3])
    GBH_FactionDetailsForm74:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][4])
    GBH_FactionDetailsForm81:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][1])
    GBH_FactionDetailsForm82:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][2])
    GBH_FactionDetailsForm83:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][3])
    GBH_FactionDetailsForm84:SetText(GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][4])
end
    
function GBH_FactionDetailsOnSave()  
    if not CanEditPublicNote() then
        GBL_LargessMessage("You do not have permission to change guild faction details.")
        return
    end
    
    --update global faction details
    local timestamp = time()
    for i = 1, GBL_MAX_NUM_GUILD_FACTIONS do
        GBL_GuildFactions[i].timestamp = timestamp
    end
    GBL_GuildFactions[GBH_CurrentFactionIndex].title = GBH_FactionDetailsFormName:GetText()   
    GBL_GuildFactions[GBH_CurrentFactionIndex].description = GBH_FactionDetailsFormDescription:GetText()  
    GBL_GuildFactions[GBH_CurrentFactionIndex].goldtorep = GBH_FactionDetailsFormMoneyRepGold:GetText()
    GBL_GuildFactions[GBH_CurrentFactionIndex].bountytorep = GBH_FactionDetailsFormBountyRepGold:GetText()
    GBL_GuildFactions[GBH_CurrentFactionIndex].repairstorep = GBH_FactionDetailsFormRepairsRepGold:GetText()
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][1] = tonumber(GBH_FactionDetailsForm11:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][2] = tonumber(GBH_FactionDetailsForm12:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][3] = tonumber(GBH_FactionDetailsForm13:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[1][4] = tonumber(GBH_FactionDetailsForm14:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][1] = tonumber(GBH_FactionDetailsForm21:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][2] = tonumber(GBH_FactionDetailsForm22:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][3] = tonumber(GBH_FactionDetailsForm23:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[2][4] = tonumber(GBH_FactionDetailsForm24:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][1] = tonumber(GBH_FactionDetailsForm31:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][2] = tonumber(GBH_FactionDetailsForm32:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][3] = tonumber(GBH_FactionDetailsForm33:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[3][4] = tonumber(GBH_FactionDetailsForm34:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][1] = tonumber(GBH_FactionDetailsForm41:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][2] = tonumber(GBH_FactionDetailsForm42:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][3] = tonumber(GBH_FactionDetailsForm43:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[4][4] = tonumber(GBH_FactionDetailsForm44:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][1] = tonumber(GBH_FactionDetailsForm51:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][2] = tonumber(GBH_FactionDetailsForm52:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][3] = tonumber(GBH_FactionDetailsForm53:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[5][4] = tonumber(GBH_FactionDetailsForm54:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][1] = tonumber(GBH_FactionDetailsForm61:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][2] = tonumber(GBH_FactionDetailsForm62:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][3] = tonumber(GBH_FactionDetailsForm63:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[6][4] = tonumber(GBH_FactionDetailsForm64:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][1] = tonumber(GBH_FactionDetailsForm71:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][2] = tonumber(GBH_FactionDetailsForm72:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][3] = tonumber(GBH_FactionDetailsForm73:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[7][4] = tonumber(GBH_FactionDetailsForm74:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][1] = tonumber(GBH_FactionDetailsForm81:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][2] = tonumber(GBH_FactionDetailsForm82:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][3] = tonumber(GBH_FactionDetailsForm83:GetText())
    GBL_GuildFactions[GBH_CurrentFactionIndex].discount[8][4] = tonumber(GBH_FactionDetailsForm84:GetText())    
    
    --update local faction detials
    GBH_FactionData[GBH_CurrentFactionIndex+1].name = GBH_FactionDetailsFormName:GetText()
    GBH_FactionData[GBH_CurrentFactionIndex+1].description = GBH_FactionDetailsFormDescription:GetText() 
   
    GBH_FactionDetailsOnShow()
    GBH_FactionSelectMenuInitialize()
    ReputationFrame_Update();
    ReputationWatchBar_Update();
    
    --send update to the guild
    GBH_GF_DoSync() 
end

--decrement the number in the reputation edit box
function GBH_RepBoxDecrement_OnClick()
    local pts = tonumber(GBH_ReputationEditBox:GetText())
    
    if pts == nil or pts == "" then
        pts = 0
    end
    
    GBH_ReputationEditBox:SetText(tostring(pts-1))
end

--increment the number in the reputation edit box
function GBH_RepBoxIncrement_OnClick()
    local pts = tonumber(GBH_ReputationEditBox:GetText())
    
    if pts == nil or pts == "" then
        pts = 0
    end
    
    GBH_ReputationEditBox:SetText(tostring(pts+1))
end