function GBH_Help(cmd)
	if cmd == "" or cmd == nil then
      GBL_LargessMessage("","sys")
      GBL_LargessMessage("--------------------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter v"..GBH_VERSION,"sys")
      GBL_LargessMessage("by Azinath","sys")
      GBL_LargessMessage("--------------------------------------","sys")
		GBL_LargessMessage("usage: /gbh <command> <args>","sys")
		GBL_LargessMessage("Type '/gbh help <command>' for info on a specific gbh command.","sys")
		GBL_LargessMessage("","sys")
		GBL_LargessMessage("Available gbh commands:","sys")
		GBL_LargessMessage("   audit","sys")
		GBL_LargessMessage("   bounty","sys")
		GBL_LargessMessage("   clear","sys")
		GBL_LargessMessage("   cut","sys")
		GBL_LargessMessage("   intel","sys")
		GBL_LargessMessage("   largess","sys")
		GBL_LargessMessage("   list","sys")
		GBL_LargessMessage("   sync","sys")
        GBL_LargessMessage("   gbimport","sys")
        GBL_LargessMessage("   setminrank","sys")
    elseif cmd == "audit" then
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("Audit","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("usage: /gbh audit [bounties]","sys")
		GBL_LargessMessage("Reads the guild bank money log and bounty list and updates Largess officer notes for all new transactions.","sys")		
		GBL_LargessMessage("Requires officer note and guild info write permissions.","sys")
		GBL_LargessMessage("Requires a guild bank money log and guild roster refresh.","sys")
		GBL_LargessMessage("If the optional 'bounties' argument is used, it will only audit bounties.","sys")
		GBL_LargessMessage("Calling audit self way only requires officer note write permission.","sys")
	elseif cmd == "bounty" then
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("Bounty","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("useage: /gbh bounty [<amount> | bg <amount>]","sys")
		GBL_LargessMessage("Opens the add bounty dialog box populated with current target data.","sys")
		GBL_LargessMessage("If an amount is included \(in copper\) then the dialog box will not open and a bounty will be placed on the current target for the specified amount.","sys")
		GBL_LargessMessage("It may be useful to create a macro like self: /gbh bounty 10123","sys")
		GBL_LargessMessage("This macro could be used to quickly add a bounty to your target for 1g 1s 23c","sys")
		GBL_LargessMessage("The 'bg <amount>' option only works in a battleground.","sys")
		GBL_LargessMessage("It adds a bounty for <amount> on every enemy player currently in the battleground.","sys")
		GBL_LargessMessage("Using the 'bg' option may require a refresh of the BG Stats list.","sys")
	elseif cmd == "clear" then
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("Clear","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("useage: /gbh clear [all]","sys")
		GBL_LargessMessage("Clears your local bounty list.","sys")
		GBL_LargessMessage("Using the 'all' option also the clears the bounty lists for all online guild members.","sys")
		GBL_LargessMessage("The 'all' option requires officer note and guild info write permission.","sys")
	elseif cmd == "cut" then
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("Bank Cut","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("useage: /gbh cut <0-1>","sys")
		GBL_LargessMessage("Sets the guild bank %cut on all Largess deposits.","sys")
		GBL_LargessMessage("Requires officer note and guild info write permission.","sys")
	elseif cmd == "intel" then
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("Intel","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("useage: /gbh intel post | spy | report","sys")
		GBL_LargessMessage("Gathers intelligence data on your bounty targets \(e.g. zone, class, level\)","sys")
		GBL_LargessMessage("'post' will copy your bounty list to a variable accessible account wide.","sys")
		GBL_LargessMessage("'spy' will call /who on all friendly players from the account wide list.","sys")
		GBL_LargessMessage("'report' will copy the /who info from the account wide list to your character bounty list.","sys")
		GBL_LargessMessage("Typical usage would be to call '/gbh intel post' from the character whos list you seek intel on.","sys")
		GBL_LargessMessage("Then log onto a character of the opposite faction and call '/gbh intel spy'.","sys")
		GBL_LargessMessage("Once the data has been gathered, log back on with the first character and call '/gbh intel report'.","sys")
	elseif cmd == "largess" then
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("Largess","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("usage: /gbh largess [report | set <player> <amount> | mod <player> <amount>]","sys")
		GBL_LargessMessage("When called with no arguments, it prints the player's current largess amount.","sys")
		GBL_LargessMessage("Using the 'report' option will print the largess for all guild members.","sys")
		GBL_LargessMessage("'report' requires officer note read permission.","sys")
		GBL_LargessMessage("'set' sets <player> largess equal to <amount> \(in copper\).","sys")
		GBL_LargessMessage("'set' requires officer note write permission.","sys")
		GBL_LargessMessage("'mod' adds <amount> to <player> largess. <amount> can be negative or positive \(in copper\).","sys")
		GBL_LargessMessage("'mod' requires officer note write permission. ","sys")
		GBL_LargessMessage("Both 'set' and 'mod' accept <player='all'> to apply largess changes to all guild members.","sys")
	elseif cmd == "list" then
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("List","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("usage: /gbh list","sys")
		GBL_LargessMessage("Prints the filtered bounty list to selected channels.","sys")
	elseif cmd == "sync" then 
      GBL_LargessMessage("-----------------------------","sys")
      GBL_LargessMessage("Guild Bounty Hunter","sys")
      GBL_LargessMessage("Sync","sys")
      GBL_LargessMessage("-----------------------------","sys")
		GBL_LargessMessage("usage: /gbh sync","sys")
		GBL_LargessMessage("Forces a resynchronization of your bounty list with all online guild members.","sys")
		GBL_LargessMessage("This is done automatically on entering the game world and on UI reload.","sys")
    
    elseif cmd == "gbimport" then
        GBL_LargessMessage("-----------------------------","sys")
        GBL_LargessMessage("Guild Bounty Hunter","sys")
        GBL_LargessMessage("Guild Bank Import","sys")
        GBL_LargessMessage("-----------------------------","sys")
        GBL_LargessMessage("usage: /gbh gbimport [<discount>]","sys")
        GBL_LargessMessage("Imports all items in the guild bank into the GBH item list with prices from the Auctionator addon.","sys")
        GBL_LargessMessage("If <discount> is provided, it will apply it to the Auctionator prices.","sys")
        
    elseif cmd == "setminrank" then
        GBL_LargessMessage("-----------------------------","sys")
        GBL_LargessMessage("Guild Bounty Hunter","sys")
        GBL_LargessMessage("Set Minimum Officer Rank","sys")
        GBL_LargessMessage("-----------------------------","sys")
        GBL_LargessMessage("usage: /gbh setminrank <rankindex>","sys")
        GBL_LargessMessage("Sets the minimum officer rank for enforcing Officer Locked bounties.","sys")
        GBL_LargessMessage("GBH will not accept any bounty updates from players who's rank index is greater than <rankindex>.","sys")
	end
end
