GBL_SET_GBCUT = false
GBL_ITEMVENDOR = 0
GBVendor_Listen = false

function GBL_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED"); 	
    self:RegisterEvent("PLAYER_ENTERING_WORLD");	
	self:RegisterEvent("GUILDBANK_UPDATE_MONEY");
    self:RegisterEvent("GUILDBANKLOG_UPDATE");
    self:RegisterEvent("CHAT_MSG_ADDON");
    self:RegisterEvent("GUILD_ROSTER_UPDATE");
    self:RegisterEvent("GUILDBANK_UPDATE_TABS");
    self:RegisterEvent("GUILDBANKBAGSLOTS_CHANGED");
    self:RegisterEvent("GUILDBANKFRAME_CLOSED");
    self:RegisterEvent("GUILDBANKFRAME_OPENED");
    self:RegisterEvent("GUILDBANK_UPDATE_TEXT");
    RegisterAddonMessagePrefix("GBL_FORCE")
end

function GBL_OnEvent(self, event, ...)
    local arg1, arg2, arg3 = ...
    
	if event == "VARIABLES_LOADED" then
		GBL_Init()       
	elseif (event == "PLAYER_ENTERING_WORLD") then
		GuildRoster()      
		if not CanViewOfficerNote() then
			GBL_RosterLargessFrame:Hide()
		else
         
		end      
	end  
	
	-- Largess Audit Events
	local transt,name,amount,n,i,gbcut     
	
	if (event == "GUILDBANK_UPDATE_MONEY") then
        GBVendor_Listen = true 
		QueryGuildBankLog(MAX_GUILDBANK_TABS+1 )       
   
    elseif (event == "GUILDBANK_UPDATE_TABS") then
        --GBL_LargessMessage("GUILDBANK_UPDATE_TABS")
     
    elseif (event == "GUILDBANKFRAME_OPENED") then   
        --GBTabFlags[GetCurrentGuildBankTab()] = 1
        GBL_GuildBankOpen = true
     
    elseif (event == "GUILDBANKBAGSLOTS_CHANGED") then        
        if GBL_GuildBankOpen == true then 
            local tab = GetCurrentGuildBankTab()
            gbh_debug("GUILDBANKSLOTS_CHANGED:"..tab)
            if  GBL_LastTab == nil then 
                GBL_LastTab = 0
            end
            if GBL_LastTab ~= tab then  
                GBL_InitGBItemList()
            end
            GBL_LastTab = tab            
            if GBL_HasGBTabChanged() then
                gbh_debug("GUILDBANKSLOTS REALLY CHANGED!!!")
                GBL_ITEMVENDOR = tab
                --^ this was causing a client crash. need to prevent GBL_HasGBTabChanged from returning true on first open of GB
                QueryGuildBankLog(tab) 
            end              
        end
    
    elseif (event == "GUILDBANKFRAME_CLOSED") then        
        GBL_GuildBankOpen = false
        
    elseif (event == "GUILDBANKLOG_UPDATE") then      
		--GBL_LargessMessage(event)
        --handle GB money transactions
        if GBVendor_Listen == true then          
            transt,name,amount = GetGuildBankMoneyTransaction(GetNumGuildBankMoneyTransactions())                 
            GBVendor_Listen = false
            if transt == "deposit" then
                --gbcut = GBL_GetGBCut()
                --GBL_AddLargess(amount-floor(gbcut*amount));  
                GBL_AddLargess(amount)
                GBH_AddLocalGoldRep(amount)
            elseif transt == "withdraw" then
                amount = GBH_DiscountTransByLocalRep(amount,transt)
                GBL_SubLargess(amount);
                GBH_SubLocalGoldRep(amount)
            end
        end  
        GBL_BANKLOG_UPDATED = true
      
        --handle GB audits
        if GBL_DO_AUDIT and GBL_ROSTER_UPDATED and GBL_GUILD_BANK_TEXT_UPDATED then            
            GBL_DoAudit()            
        end
      
        --handle GB tab transactions
        local tab = GetCurrentGuildBankTab()
        if GBL_ITEMVENDOR == tab then 
            GBL_ITEMVENDOR = 0
            local typ, name, itemLink, count, tab1, tab2, y, m, d, h = GetGuildBankTransaction(tab, GetNumGuildBankTransactions(tab))             
            --transaction must be relatively new
            if h > 0 or d > 0 or m > 0 or y > 0 then
                return
            end
            GBL_LargessMessage("GB Transaction Tab:"..tab..":"..typ..":"..itemLink)
            amount = count*GBL_GetItemLargess(itemLink)
            --gbcut = GBL_GetGBCut()
            if typ == "deposit" then                
                GBL_AddLargess(amount)
                GBH_AddLocalItemRep(itemLink,count)
            elseif typ == "withdraw" then
                amount = GBH_DiscountTransByLocalRep(amount,"item",itemLink)
                GBL_SubLargess(amount)
                GBH_SubLocalItemRep(itemLink,count)
            end  
            GBL_InitGBItemList()
        end  
      
    elseif (event == "GUILD_ROSTER_UPDATE") then
        --GBL_LargessMessage("GUILD_ROSTER_UPDATE")
        local gnum = GetNumGuildMembers(true)
        local i,name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName
        
        GBL_GuildMates = {}      
        for i = 1,gnum do
            name,rank,rankIndex,level,class,zone,note,officernote,online,status,classFileName = GetGuildRosterInfo(i) 
            table.insert(GBL_GuildMates,{name=name,note=officernote,pnote=note})
        end  
       
        GBL_GuildInfoText = GetGuildInfoText()   
        GBL_ParseGuildInfoText()
        GBL_ROSTER_UPDATED = true      
        GBL_AuditInit()
        GBL_AuditLoad()   
        GBL_SetupLargessViewList()
        
        --guild faction data     
        if GBL_FactionSaveFlag == nil then    --this is essentially done only once, should be moved?         
            GBL_FactionInit()
            GBL_FactionLoad() 
        end
        --GBL_SetupFactionViewList()
      
    elseif  (event == "GUILDBANK_UPDATE_TEXT") then
        local s,e,t0,n0,a0,c0,ts0,i0,i        
        local text = GetGuildBankText(arg1)
        if GBL_GuildBankText == nil then
            GBL_GuildBankText = {}
        end
        if GBL_GUILDBANK_TEXT == nil then
            GBL_GUILDBANK_TEXT = {}
        end
        
        --guild bank text
        GBL_GuildBankText[arg1] = text  
        GBL_GUILDBANK_TEXT[arg1] = true       
        GBL_GUILD_BANK_TEXT_UPDATED = true
        for i = 1, GetNumGuildBankTabs() do
            if GBL_GUILDBANK_TEXT[i] == "" then
                GBL_GUILD_BANK_TEXT_UPDATED = false
                break
            end
        end        
        
        --guild bank cut
        if GBL_GUILDBANK_TEXT[1] == true and GBL_SET_GBCUT == true then            
            GBL_SetGBCut(GBL_GBCut)
            GBL_SET_GBCUT = false            
        end
        
        GBL_msg(event..":"..arg1)

    elseif (event == "CHAT_MSG_ADDON") then
        if arg1 == "GBL_FORCE" then
            GBL_LargessMessage("GBL_FORCE: "..arg2)
            GBL_Largess = tonumber(arg2)
        end 
        
    end  
end

function GBL_Init()
	SLASH_GBL1 = "/gbl"
	SlashCmdList["GBL"] = GBL_Commands;   
	GBL_RosterLargessFrame:SetScript("OnUpdate",function() GBL_RosterLargessUpdate() end)
	GBL_VERSION = GetAddOnMetadata("GBL", "version")
	GBL_AUDIT_DELAY = 20
	GBVendor_Listen = false
	GBL_ITEMVENDOR = 0
	GBL_GBNUMSLOTS = 98
    if GBL_Config == nil then
        GBL_Config = {}
        GBL_Config["auditors"] = false
    end
end   

function GBL_msg(msg)
  --GBL_LargessMessage(msg)
end

function GBL_ParseGuildInfoText()
    if GBL_GuildInfoText == nil or GBL_GuildInfoText == "" then
        return
    end
    
    local s,e,minoffrank = string.find(GBL_GuildInfoText,"<GBH><MinOfficerRank=(.+)></GBH>")
    if minoffrank ~= nil then
        GBH_MinOfficerRank = minoffrank
    end
end   

function GBL_SetMinOfficerRank(mor) 
    if not CanEditGuildInfo() then
        GBL_LargessMessage("You do not have permission to change guild info.")
        return
    end
    
    local ginfo, n = string.gsub(GBL_GuildInfoText,"<GBH><MinOfficerRank=.+></GBH>", "<GBH><MinOfficerRank="..mor.."></GBH>") 
    
    if n == 1 then  
       --found GBH parameter string in guild info      
       GBL_GuildInfoText = ginfo 
    else    
       --did not find GBH parameter string
       GBL_LargessMessage("Adding GBH parameter string to guild info text now.")
       GBL_GuildInfoText = ginfo.."<GBH><MinOfficerRank="..mor.."></GBH>"
    end      
   
    SetGuildInfoText(GBL_GuildInfoText)    
end