GBL_ItemPriceList = {}

function GBL_AuditBankTabs()
    local rep1, rep2, rep3, rep4, rep5
    local repi1, repi2, repi3, repi4, repi5
    
    if not CanEditGuildInfo() then
        GBL_LargessMessage("You do not have permission to audit the guild bank.")
        return
	end
   
    local ntabs, tab, typ, name, itemLink, amount, y, m, d, h
    ntabs = GetNumGuildBankTabs()

    for tab = 1, ntabs do
        local num = GetNumGuildBankTransactions(tab)
		local i,ts,allnew,lasttrans
        local nonew = true
   
        GBL_LoadLastTabAudit(tab)   

        if GBL_AuditData["last"..tab].t0 == "" then 
            --GBL_LargessMessage("t"..tab..": "..GBL_AuditData["last"..tab].t0,"red")
            -- if we don't have a last audit, they're all new
            allnew = true
        else
            -- we've got audit data, let's use it
            allnew = false
        end 
        
        GBL_LargessMessage("Tab:"..tab)
        
        for i = 1,num do    
            lasttrans = GBL_IsTabTransactionNew(tab,i)
            if allnew or lasttrans==true then		         
                --typ, name, amount, y, m, d, h = GetGuildBankMoneyTransaction(i)  
                typ, name, itemLink, count, tab1, tab2, y, m, d, h = GetGuildBankTransaction(tab, i) 
                --itemLink = GetItemInfo(itemLink)
                amount = count*GBL_GetItemLargess(itemLink)
                
                --get item rep
                repi1, repi2, repi3, repi4, repi5 = GBL_GetFactionItemRep(itemLink)
                
                gbh_debug("Item rep:"..repi1..":"..repi2..":"..repi3..":"..repi4..":"..repi5)
                
                repi1 = repi1*count
                repi2 = repi2*count
                repi3 = repi3*count
                repi4 = repi4*count                
                repi5 = repi5*count 
                
                rep1, rep2, rep3, rep4, rep5 = GBL_FactionGetRep(name)
                if not (name == nil) then  --ignore nil transactions
                    nonew = false
                    GBL_msg("New:"..i..":"..typ..":"..name..":"..amount)     
                    if typ == "deposit" then
                        GBL_LargessMessage("New Transaction: "..name..":"..typ..":"..itemLink..":"..d..":"..h)
                        --local gbcut = GBL_GetGBCut()
                        if GBL_AuditData[name] then
                            GBL_AuditData[name].largess = GBL_AuditData[name].largess + amount                            
                            --adjust rep
                            GBL_FactionSetRep(name, rep1+repi1, rep2+repi2, rep3+repi3, rep4+repi4, rep5+repi5)
                        end
                    elseif typ == "withdraw" then
                       GBL_LargessMessage("New Transaction: "..name..":"..typ..":"..itemLink..":"..d..":"..h, "red")
                       amount = GBL_DiscountTransByRep(amount,"item",itemLink)
                       if GBL_AuditData[name] then
                          GBL_AuditData[name].largess = GBL_AuditData[name].largess - tonumber(amount)
                          --adjust rep
                          GBL_FactionSetRep(name, rep1-repi1, rep2-repi2, rep3-repi3, rep4-repi4, rep5-repi5)
                       end
                    end     
                    GBL_UpdateLastTabTransaction(tab,i)  
                end
            elseif lasttrans == 2 then
                 allnew = true
            end         
            GBL_msg("Old:"..i)
        end  
        GBL_SaveLastTabAudit(tab)  
        if nonew then
            GBL_LargessMessage("No new guild bank transactions.")
        end 
    end    
    
    --SetGuildInfoText(GBL_GuildInfoText)
    GuildRoster()           
    
    GBL_DO_AUDIT = false
    GBL_ROSTER_UPDATED = false
    GBL_BANKLOG_UPDATED = false
    GBL_GUILD_BANK_TEXT_UPDATED = false
    GBL_GUILDBANK_TEXT = {}
   
end

function GBL_IsTabTransactionNew(tab,i)
   --should change self function name to 
   --GBL_IsTranscationLastAudit
	local t0 = GBL_AuditData["last"..tab].t0
	local n0 = GBL_AuditData["last"..tab].n0
	local i0 = GBL_AuditData["last"..tab].i0  --item name
    local s0 = GBL_AuditData["last"..tab].s0  --stack count
	local y0 = GBL_AuditData["last"..tab].y0
	local m0 = GBL_AuditData["last"..tab].m0
	local d0 = GBL_AuditData["last"..tab].d0
	local h0 = GBL_AuditData["last"..tab].h0	
	local c0 = GBL_AuditData["last"..tab].c0
	local ts0 = GBL_AuditData["last"..tab].ts0
	--local ti,ni,ai,yi,mi,di,hi = GetGuildBankMoneyTransaction(i)
    local ti, ni, ii, si, tab1, tab2, yi, mi, di, hi = GetGuildBankTransaction(tab, i)    
    ii = GetItemInfo(ii)
   if ni == nil then
      GBL_msg("ni==nil")
      return true
   end
   --local ts0 = GBL_GetTransactionTimeStamp(y0,m0,d0,h0)
   local tsi = GBL_GetTransactionTimeStamp(yi,mi,di,hi)
   local ci   
   
   --GBL_msg("IsNew?:"..i..":"..tsi..":"..ts0..":"..ni..":"..ii..":"..ti)
    if t0 == "" then 
        GBL_msg("t0==nil")
        return true 
    end
   --upper bounds of temporal certaintly (definately new)
   if tsi > (ts0 + 3600) then
      GBL_msg("state1")
      return true
   end
   --lower bounds of temporal certainty (definately old)
   if tsi < (ts0 -3600) then
       GBL_msg("state 2")
      return false
   end   
   
   --we couldn't tell by our timestamp alone
   --check other transaction parameters
	if not (ni == n0) then
      GBL_msg("state3")
      return false
   end
	if not (ti == t0) then 
      GBL_msg("state4:"..ti.."~="..t0)
      return false
   end
	if not (ii == i0) then 
     GBL_msg("state5:"..ii..":"..i0)
      return false 
   end
   if not (si == s0) then
        GBL_msg("state6:"..si..":"..s0)
        return false
    end
   
   -- transactioni == transaction0 at self point
   -- could we have reached the last saved transaction?
   -- how many have we had within the zone of temporal uncertainty?
   ci = GBL_CntSimTabTrans(tab,i)     
   
   if ci == c0 then
      --self is the last audit transaction
      GBL_msg("ci==c0")
      return 2
   end
   
   if ci > c0 then 
      --looks like we've got a new one, self means the rest must be new too      
		GBL_AuditData["last"..tab].c0 = c0 + 1
      GBL_msg("state6:ci: "..ci.." c0: "..c0)
		return true
	else 
      GBL_msg("state7")
		return false 
	end 
end

function GBL_CntSimTabTrans(tab, i)
	local j
	local c = 0
	local ti,ni,ii,si,tab1,tab2,yi,mi,di,hi = GetGuildBankTransaction(tab, i)
    ii = GetItemInfo(ii)
   if ni == nil then
      return 0
   end
	local tj,nj,ij,sj,yj,mj,dj,hj
   local stri,strj 
   
	for j = 1,i-1 do      
		tj,nj,ij,sj,tab1,tab2,yj,mj,dj,hj = GetGuildBankTransaction(tab, j)
        ij = GetItemInfo(ij)
      if not (nj == nil) then
         stri = ti..ni..ii..si..yi..mi..di..hi 
         strj = tj..nj..ij..sj..yj..mj..dj..hj
         if ( stri == strj ) then
            c = c + 1
         end
      end
	end	
   GBL_msg("GBL_CntSimTrans: "..c)
	return c
end

function GBL_UpdateLastTabTransaction(tab,i)
	local ti,ni,ii,si,tab1,tab2,yi,mi,di,hi = GetGuildBankTransaction(tab, i)
    ii = GetItemInfo(ii)
   if ni == nil then
      return
   end
	local tsi = GBL_GetTransactionTimeStamp(yi,mi,di,hi)
	
	GBL_AuditData["last"..tab].t0 = ti
	GBL_AuditData["last"..tab].n0 = ni
	GBL_AuditData["last"..tab].i0 = ii
    GBL_AuditData["last"..tab].s0 = si
	GBL_AuditData["last"..tab].y0 = yi
	GBL_AuditData["last"..tab].m0 = mi
	GBL_AuditData["last"..tab].d0 = di
	GBL_AuditData["last"..tab].h0 = hi
    GBL_AuditData["last"..tab].c0 = GBL_CntSimTabTrans(tab,i)
    GBL_AuditData["last"..tab].ts0 = tsi
   
end

function GBL_LoadLastTabAudit(tab)    
    --if not GBL_Config["auditors"] == true then
        --return
    --end
    
    if GBL_GuildBankText[tab] == "" then
        --condense this logic plz
        GBL_AuditData["last"..tab] = {}
        GBL_AuditData["last"..tab].t0 = ""
        GBL_AuditData["last"..tab].n0 = ""
        GBL_AuditData["last"..tab].i0 = ""
        GBL_AuditData["last"..tab].s0 = 0
        GBL_AuditData["last"..tab].y0 = 0
        GBL_AuditData["last"..tab].m0 = 0
        GBL_AuditData["last"..tab].d0 = 0
        GBL_AuditData["last"..tab].h0 = 0
        GBL_AuditData["last"..tab].c0 = 0
        GBL_AuditData["last"..tab].ts0 = 0       
        return
    end
      
    local s,e,t0,n0,i0,s0,c0,ts0 = string.find(GBL_GuildBankText[tab],"<GBL:T"..tab.."><(.+)><(.+)><(.+)><(.+)><(.+)><(.+)></T"..tab..">")
   
   if not (s == nil) then
      GBL_msg("Loading last audit "..string.sub(GBL_GuildBankText[tab],s,e))
   end
   
   if t0 then  
      GBL_msg("t0 exists")
      --GBL_AuditData = {}
      GBL_AuditData["last"..tab] = {}
      GBL_AuditData["last"..tab].t0 = t0
      GBL_AuditData["last"..tab].n0 = n0
      GBL_AuditData["last"..tab].i0 = i0
      GBL_AuditData["last"..tab].s0 = tonumber(s0)
      GBL_AuditData["last"..tab].y0 = tonumber(y0)
      GBL_AuditData["last"..tab].m0 = tonumber(m0)
      GBL_AuditData["last"..tab].d0 = tonumber(d0)
      GBL_AuditData["last"..tab].h0 = tonumber(h0)
      GBL_AuditData["last"..tab].c0 = tonumber(c0)
      GBL_AuditData["last"..tab].ts0 = tonumber(ts0)     
   else
      GBL_msg("t0 is nil")
      --GBL_AuditData = {}
      --with self redundant logic
      GBL_AuditData["last"..tab] = {}
      GBL_AuditData["last"..tab].t0 = ""
      GBL_AuditData["last"..tab].n0 = ""
      GBL_AuditData["last"..tab].i0 = ""
      GBL_AuditData["last"..tab].s0 = 0
      GBL_AuditData["last"..tab].y0 = 0
      GBL_AuditData["last"..tab].m0 = 0
      GBL_AuditData["last"..tab].d0 = 0
      GBL_AuditData["last"..tab].h0 = 0
      GBL_AuditData["last"..tab].c0 = 0
      GBL_AuditData["last"..tab].ts0 = 0       
   end
   --GBL_msg("LoadLastAudit:t0:"..GBL_AuditData["last"].t0..":n0"..GBL_AuditData["last"].n0..":a0"..GBL_AuditData["last"].a0)
end

function GBL_SaveLastTabAudit(tab)
     --if not GBL_Config["auditors"] == true then
       -- return
    --end
    
   if not CanEditGuildTabInfo(tab) then
        GBL_LargessMessage("You do not have permission to audit tab "..tab..".")
      return
   end
   
   local s,e,t0,n0,i0,s0,y0,m0,d0,h0,c0,ts0,ginfo,n
   t0 = GBL_AuditData["last"..tab].t0
   n0 = GBL_AuditData["last"..tab].n0
   i0 = GBL_AuditData["last"..tab].i0
   s0 = GBL_AuditData["last"..tab].s0
   y0 = GBL_AuditData["last"..tab].y0
   m0 = GBL_AuditData["last"..tab].m0
   d0 = GBL_AuditData["last"..tab].d0
   h0 = GBL_AuditData["last"..tab].h0
   c0 = GBL_AuditData["last"..tab].c0
   ts0 = GBL_AuditData["last"..tab].ts0     
   --cut = GBL_GetGBCut()
   
   ginfo,n = string.gsub(GBL_GuildBankText[tab],"<GBL:T"..tab.."><.+><.+><.+><.+><.+><.+></T"..tab..">","<GBL:T"..tab.."><"..t0.."><"..n0.."><"..i0.."><"..s0.."><"..c0.."><"..ts0.."></T"..tab..">")  
   --GBL_LargessMessage(GBL_GuildBankText[1])
    
   if n == 1 then  
      --found audit string in guild info      
      GBL_GuildBankText[tab] = ginfo 
   else    
      --did not find audit string, so add it
      GBL_LargessMessage("Could not find tab "..tab.." audit string in bank text:"..GBL_GuildBankText[tab] )
      GBL_GuildBankText[tab] = ginfo.."<GBL:T"..tab.."><"..t0.."><"..n0.."><"..i0.."><"..s0.."><"..c0.."><"..ts0.."></T"..tab..">"      
   end  
   --GBL_LargessMessage(GBL_GuildBankText[1])
   --GBL_AuditBank()
   SetGuildBankText(tab, GBL_GuildBankText[tab])
   QueryGuildBankText(tab)
end

function GBL_GetItemLargess(item) 
    local name, link, quality, iLevel,  reqLevel, class, subclass, maxStack,  equipSlot, texture, vendorPrice = GetItemInfo(item)
    local auctionPrice
    
    --check price table first
    local i    
    for i = 1, #GBL_ItemLargess do
        if GBL_ItemLargess[i].item == link then
            return GBL_ItemLargess[i].largess
        end
    end        
    
    --check for auction price
    local _,_,_,gotauc,_,_,_ = GetAddOnInfo("Auctionator")
    if gotauc then
        auctionPrice = GetAuctionBuyout(item)
    end
    if auctionPrice == nil then
        auctionPrice = 0
    end
    
    --check vendor price
    if vendorPrice == nil then
        vendorPrice = 0
    end
    
    --use higher price
    --if auctionPrice > vendorPrice then
    --    return auctionPrice
    --else
        return vendorPrice       
    --end
end
