--bonus index
GBL_BONUS_MAT_ENCH =    1
GBL_BONUS_MAT_MINE =    2
GBL_BONUS_MAT_CLOTH =   3
GBL_BONUS_MAT_SKIN =    4
GBL_BONUS_MAT_HERB =    5
GBL_BONUS_MAT_GEM =     30
GBL_BONUS_CRAFT_ALCH =    
GBL_BONUS_TAB_01 =      6
GBL_BONUS_TAB_02 =      7
GBL_BONUS_TAB_03 =      8 
GBL_BONUS_TAB_04 =      9
GBL_BONUS_TAB_05 =      10
GBL_BONUS_TAB_06 =      11
GBL_BONUS_TAB_07 =      12
GBL_BONUS_TAB_08 =      13
GBL_BONUS_BOUNTY =      14

--discount index
GBL_DISCOUNT_MAT_ENCH =     15 
GBL_DISCOUNT_MAT_MINE =     16
GBL_DISCOUNT_MAT_CLOTH =    17
GBL_DISCOUNT_MAT_SKIN =     18
GBL_DISCOUNT_MAT_HERB =     19
GBL_DISCOUNT_MAT_GEM =      31
GBL_DISCOUNT_TAB_01 =       20
GBL_DISCOUNT_TAB_02 =       21
GBL_DISCOUNT_TAB_03 =       22
GBL_DISCOUNT_TAB_04 =       23
GBL_DISCOUNT_TAB_05 =       24
GBL_DISCOUNT_TAB_06 =       25
GBL_DISCOUNT_TAB_07 =       26
GBL_DISCOUNT_TAB_08 =       27
GBL_DISCOUNT_BOUNTY =       28
GBL_DISCOUNT_REPAIR =       29
GBL_DISCOUNT_GBCUT =        32

--Define Default GBL Roles
GBL_Roles = {}

--treasurer 
GBL_Roles[1] = {}
GBL_Roles[1].title = "Treasurer"
GBL_Roles[1].bonus = {}
table.insert(GBL_Roles[1].bonus, {type="NO_LARGESS"})

--alchemist
GBL_Roles[2] = {}
GBL_Roles[2].title = "Alchemist"
GBL_Roles[2].bonus = {}
table.insert(GBL_Roles[2].bonus, {type= GBL_DISCOUNT_HERB, amount=0.5})
table.insert(GBL_Roles[2].bonus, {type="BONUS_ALCH", amount=0.5})

--blacksmith
GBL_Roles[3] = {}
GBL_Roles[3].title = "Blacksmith"
GBL_Roles[3].bonus = {}
table.insert(GBL_Roles[3].bonus, {type="DISCOUNT_MINE", amount=0.5})
table.insert(GBL_Roles[3].bonus, {type="BONUS_SMITH", amount=0.5})

--engineer
GBL_Roles[4] = {}
GBL_Roles[4].title = "Engineer"
GBL_Roles[4].bonus = {}
table.insert(GBL_Roles[4].bonus, {type="DISCOUNT_MINE", amount=0.5})
table.insert(GBL_Roles[4].bonus, {type="BONUS_ENG", amount=0.5})

--enchanter
GBL_Roles[5] = {}
GBL_Roles[5].title = "Enchanter"
GBL_Roles[5].bonus = {}
table.insert(GBL_Roles[5].bonus, {type="DISCOUNT_ENCH", amount=0.5})
table.insert(GBL_Roles[5].bonus, {type="BONUS_ENCH", amount=0.5})

--gatherer
GBL_Roles[6] = {}
GBL_Roles[6].title = "Gatherer"
GBL_Roles[6].bonus = {}
table.insert(GBL_Roles[6].bonus, {type="BOUNUS_HERB", amount=0.5})
table.insert(GBL_Roles[6].bonus, {type="BONUS_MINE", amount=0.5})
table.insert(GBL_Roles[6].bonus, {type="BONUS_LEATHER", amount=0.5})
table.insert(GBL_Roles[6].bonus, {type="BONUS_ENCH", amount=0.5})
table.insert(GBL_Roles[6].bonus, {type="BONUS_CLOTH", amount=0.5})

--herbalist
GBL_Roles[7] = {}
GBL_Roles[7].title = "Herbalist"
GBL_Roles[7].bonus = {}
table.insert(GBL_Roles[7].bonus, {type="BONUS_HERB", amount=1})

--jewelcrafter
GBL_Roles[8] = {}
GBL_Roles[8].title = "Jewelcrafter"
GBL_Roles[8].bonus = {}
table.insert(GBL_Roles[8].bonus, {type="DISCOUNT_GEM", amount=0.5})
table.insert(GBL_Roles[8].bonus, {type="DISCOUNT_MINE", amount=0.5})
table.insert(GBL_Roles[8].bonus, {type="BONUS_JEWEL", amount=0.5})

--leatherworker
GBL_Roles[9] = {}
GBL_Roles[9].title = "Jewelcrafter"
GBL_Roles[9].bonus = {}
table.insert(GBL_Roles[9].bonus, {type="DISCOUNT_LEATHER", amount=0.5})
table.insert(GBL_Roles[9].bonus, {type="BONUS_LEATHER", amount=0.5})

--scribe
GBL_Roles[10] = {}
GBL_Roles[10].title = "Scribe"
GBL_Roles[10].bonus = {}
table.insert(GBL_Roles[10].bonus, {type="DISCOUNT_HERB", amount=0.5})
table.insert(GBL_Roles[10].bonus, {type="BONUS_SCRIBE", amount=0.5})

--skinner
GBL_Roles[11] = {}
GBL_Roles[11].title = "Skinner"
GBL_Roles[11].bonus = {}
table.insert(GBL_Roles[11].bonus, {type="BONUS_LEATHER", amount=1})

--tailor
GBL_Roles[12].title = "Tailor"
GBL_Roles[12].bonus = {}
table.insert(GBL_Roles[12].bonus, {type="DISCOUNT_TAIL", amount=0.5})
table.insert(GBL_Roles[12].bonus, {type="BONUS_TAIL", amount=0.5})

--raider
GBL_Roles[13].title = "Raider"
GBL_Roles[13].bonus = {}
table.insert(GBL_Roles[13].bonus, {type="DISCOUNT_REPAIR", amount=0.5})

--assassin
GBL_Roles[14].title = "Assassin"
GBL_Roles[14].bonus = {}
table.insert(GBL_Roles[14].bonus, {type="BONUS_BOUNTY", amount=0.25})

--modify largess transactions based on players' guild bank role
function GBL_ModLargessByRole(player, transtype, amount, item, tab)
    local role = GBL_GetGuildRole(player)
    
    if role == nil then 
        return amount
    end
    
    local bonuses = GBL_Roles[role]
    local isBagType
    
    if bonuses == nil then
        return amount
    end
    
    local bonus, i
    
    for i = 1,#bonuses do
    
        bonus = bonuses[i].type
        
        --no guild bank cut on deposits
        if bonus == "DISCOUNT_GBCUT" then
            if item == nil or arg1 == nil then
                return
            end
            if transtype == "DEPOSIT" then
                local cut = GBL_GetGBCut()
                cut = cut*arg1
                return ceil(amount/(1-cut)) --wrong!!!
            end
        
        --discount herbs
        elseif bonus == GBL_DISCOUNT_HERB then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0020)
            if isBagType and transtype == "WITHDRAW" then
                return amount - amount*arg1
            end
            
        --discount minerals
        elseif bonus == "DISCOUNT_MINE" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0400)
            if isBagType and transtype == "WITHDRAW" then
                return amount - amount*arg1
            end
            
        --discount enchanting
        elseif bonus == "DISCOUNT_ENCH" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0040)
            if isBagType and transtype == "WITHDRAW" then
                return amount - amount*arg1
            end    
            
        --discount jewelcrafting
        elseif bonus == "DISCOUNT_GEM" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0200)
            if isBagType and transtype == "WITHDRAW" then
                return amount - amount*arg1
            end
            
        --discount leatherworking
        elseif bonus == "DISCOUNT_LEATHER" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0008)
            if isBagType and transtype == "WITHDRAW" then
                return amount - amount*arg1
            end   
            
        --discount inscription
        elseif bonus == "DISCOUNT_INS" then
            if item == nil or arg1 == nil then
                return
            end      
            isBagType = bit.bor(GetItemFamily(item), 0x0010)
            if isBagType and transtype == "WITHDRAW" then
                return amount - amount*arg1
            end
            
        --discount tailoring
        elseif bonus == "DISCOUNT_TAIL" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item),32)
            if isBagType and transtype == "WITHDRAW" then
                return amount - amount*arg1
            end
            
        --discount repairs
        elseif bonus == "DISCOUNT_REPAIR" then
            if transtype == "repair" then
                return amount - amount*arg1
            end
            
        --discount bank tab 
        elseif bonus == "DISCOUNT_TAB" then
            if transtype == "withdraw" and tab == arg1 then
                return amount - amount*arg2
            end
            
        --bonus minerals
        elseif bonus == "BONUS_MINE" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0400)
            if isBagType and transtype == "DEPOSIT" then
                return amount + amount*arg1
            end
        
        --bonus herbs
        elseif bonus == "BONUS_HERB" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0020)
            if isBagType and transtype == "DEPOSIT" then
                return amount + amount*arg1
            end                   
        
        --bonus leather
        elseif bonus == "BONUS_LEATHER" then
            if item == nil or arg1 == nil then
                return
            end
            isBagType = bit.bor(GetItemFamily(item), 0x0008)
            if isBagType and transtype == "DEPOSIT" then
                return amount + amount*arg1
            end           
        
        --no largess applied to any bank transaction
        elseif bonus == "NO_LARGESS" then 
            return 0
        
        end
    end
end
 
--extract roles from public note 
function GBL_GetGuildRole(player)
    if GBL_AuditData == nil then 
        GuildRoster()
        return
    end
        
    if GBL_AuditData[player].pnote == nil then
        GuildRoster()
        return
    end
     
    local pnote = GBL_AuditData[player].pnote
    local role1 = tonumber(string.sub(pnote,1,2))
    local role2 = tonumber(string.sub(pnote,2,3))
    
    return role1, role2
end

